/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Util.xs. Do not edit this file, edit Util.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Util.xs"
/**********************************************************************
 * PostgreSQL::InServer::Util
 *
 * src/pl/plperl/Util.xs
 *
 * Defines plperl interfaces for general-purpose utilities.
 * This module is bootstrapped as soon as an interpreter is initialized.
 * Currently doesn't define a PACKAGE= so all subs are in main:: to avoid
 * the need for explicit importing.
 *
 **********************************************************************/

/* this must be first: */
#include "postgres.h"
#include "fmgr.h"
#include "utils/builtins.h"
#include "utils/bytea.h"       /* for byteain & byteaout */
#include "mb/pg_wchar.h"       /* for GetDatabaseEncoding */
/* Defined by Perl */
#undef _

/* perl stuff */
#include "plperl.h"
#include "plperl_helpers.h"

/*
 * Implementation of plperl's elog() function
 *
 * If the error level is less than ERROR, we'll just emit the message and
 * return.  When it is ERROR, elog() will longjmp, which we catch and
 * turn into a Perl croak().  Note we are assuming that elog() can't have
 * any internal failures that are so bad as to require a transaction abort.
 *
 * This is out-of-line to suppress "might be clobbered by longjmp" warnings.
 */
static void
do_util_elog(int level, SV *msg)
{
	MemoryContext oldcontext = CurrentMemoryContext;
	char	   * volatile cmsg = NULL;

	PG_TRY();
	{
		cmsg = sv2cstr(msg);
		elog(level, "%s", cmsg);
		pfree(cmsg);
	}
	PG_CATCH();
	{
		ErrorData  *edata;

		/* Must reset elog.c's state */
		MemoryContextSwitchTo(oldcontext);
		edata = CopyErrorData();
		FlushErrorState();

		if (cmsg)
			pfree(cmsg);

		/* Punt the error to Perl */
		croak("%s", edata->message);
	}
	PG_END_TRY();
}

static text *
sv2text(SV *sv)
{
	char	   *str = sv2cstr(sv);

	return cstring_to_text(str);
}

#line 84 "Util.c"

XS(XS___aliased_constants); /* prototype to pass -Wmissing-prototypes */
XS(XS___aliased_constants)
{
    dXSARGS;
    dXSI32;
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s()", GvNAME(CvGV(cv)));
    {
	int	RETVAL;
	dXSTARG;
#line 90 "Util.xs"
    /* uses the ALIAS value as the return value */
    RETVAL = ix;
#line 99 "Util.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS__elog); /* prototype to pass -Wmissing-prototypes */
XS(XS__elog)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: elog(level, msg)");
    {
	int	level = (int)SvIV(ST(0));
	SV *	msg = ST(1);
#line 101 "Util.xs"
        if (level > ERROR)      /* no PANIC allowed thanks */
            level = ERROR;
        if (level < DEBUG5)
            level = DEBUG5;
        do_util_elog(level, msg);
#line 121 "Util.c"
    }
    XSRETURN_EMPTY;
}


XS(XS__quote_literal); /* prototype to pass -Wmissing-prototypes */
XS(XS__quote_literal)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: quote_literal(sv)");
    {
	SV *	sv = ST(0);
	SV *	RETVAL;
#line 111 "Util.xs"
    if (!sv || !SvOK(sv)) {
        RETVAL = &PL_sv_undef;
    }
    else {
        text *arg = sv2text(sv);
        text *ret = DatumGetTextP(DirectFunctionCall1(quote_literal, PointerGetDatum(arg)));
		char *str = text_to_cstring(ret);
		RETVAL = cstr2sv(str);
		pfree(str);
    }
#line 147 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__quote_nullable); /* prototype to pass -Wmissing-prototypes */
XS(XS__quote_nullable)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: quote_nullable(sv)");
    {
	SV *	sv = ST(0);
	SV *	RETVAL;
#line 128 "Util.xs"
    if (!sv || !SvOK(sv))
	{
        RETVAL = cstr2sv("NULL");
    }
    else
	{
        text *arg = sv2text(sv);
        text *ret = DatumGetTextP(DirectFunctionCall1(quote_nullable, PointerGetDatum(arg)));
		char *str = text_to_cstring(ret);
		RETVAL = cstr2sv(str);
		pfree(str);
    }
#line 177 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__quote_ident); /* prototype to pass -Wmissing-prototypes */
XS(XS__quote_ident)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: quote_ident(sv)");
    {
	SV *	sv = ST(0);
#line 147 "Util.xs"
        text *arg;
        text *ret;
		char *str;
#line 197 "Util.c"
	SV *	RETVAL;
#line 151 "Util.xs"
        arg = sv2text(sv);
        ret = DatumGetTextP(DirectFunctionCall1(quote_ident, PointerGetDatum(arg)));
		str = text_to_cstring(ret);
		RETVAL = cstr2sv(str);
		pfree(str);
#line 205 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__decode_bytea); /* prototype to pass -Wmissing-prototypes */
XS(XS__decode_bytea)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: decode_bytea(sv)");
    {
	SV *	sv = ST(0);
#line 163 "Util.xs"
        char *arg;
        text *ret;
#line 224 "Util.c"
	SV *	RETVAL;
#line 166 "Util.xs"
        arg = SvPVbyte_nolen(sv);
        ret = DatumGetTextP(DirectFunctionCall1(byteain, PointerGetDatum(arg)));
        /* not cstr2sv because this is raw bytes not utf8'able */
        RETVAL = newSVpvn(VARDATA(ret), (VARSIZE(ret) - VARHDRSZ));
#line 231 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__encode_bytea); /* prototype to pass -Wmissing-prototypes */
XS(XS__encode_bytea)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: encode_bytea(sv)");
    {
	SV *	sv = ST(0);
#line 177 "Util.xs"
        text *arg;
        char *ret;
		STRLEN len;
#line 251 "Util.c"
	SV *	RETVAL;
#line 181 "Util.xs"
        /* not sv2text because this is raw bytes not utf8'able */
        ret = SvPVbyte(sv, len);
		arg = cstring_to_text_with_len(ret, len);
        ret = DatumGetCString(DirectFunctionCall1(byteaout, PointerGetDatum(arg)));
        RETVAL = cstr2sv(ret);
#line 259 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__looks_like_number); /* prototype to pass -Wmissing-prototypes */
XS(XS__looks_like_number)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: looks_like_number(sv)");
    {
	SV *	sv = ST(0);
	SV *	RETVAL;
#line 193 "Util.xs"
    if (!SvOK(sv))
        RETVAL = &PL_sv_undef;
    else if ( looks_like_number(sv) )
        RETVAL = &PL_sv_yes;
    else
        RETVAL = &PL_sv_no;
#line 283 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__encode_typed_literal); /* prototype to pass -Wmissing-prototypes */
XS(XS__encode_typed_literal)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: encode_typed_literal(sv, typname)");
    {
	SV *	sv = ST(0);
	char *	typname = (char *)SvPV_nolen(ST(1));
#line 207 "Util.xs"
		char 	*outstr;
#line 302 "Util.c"
	SV *	RETVAL;
#line 209 "Util.xs"
		outstr = plperl_sv_to_literal(sv, typname);
		if (outstr == NULL)
			RETVAL = &PL_sv_undef;
		else
			RETVAL = cstr2sv(outstr);
#line 310 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_PostgreSQL__InServer__Util); /* prototype to pass -Wmissing-prototypes */
XS(boot_PostgreSQL__InServer__Util)
{
    dXSARGS;
    char* file = __FILE__;

    {
        CV * cv ;

        cv = newXS("_aliased_constants", XS___aliased_constants, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "") ;
        cv = newXS("ERROR", XS___aliased_constants, file);
        XSANY.any_i32 = ERROR ;
        sv_setpv((SV*)cv, "") ;
        cv = newXS("INFO", XS___aliased_constants, file);
        XSANY.any_i32 = INFO ;
        sv_setpv((SV*)cv, "") ;
        cv = newXS("DEBUG", XS___aliased_constants, file);
        XSANY.any_i32 = DEBUG2 ;
        sv_setpv((SV*)cv, "") ;
        cv = newXS("WARNING", XS___aliased_constants, file);
        XSANY.any_i32 = WARNING ;
        sv_setpv((SV*)cv, "") ;
        cv = newXS("NOTICE", XS___aliased_constants, file);
        XSANY.any_i32 = NOTICE ;
        sv_setpv((SV*)cv, "") ;
        cv = newXS("LOG", XS___aliased_constants, file);
        XSANY.any_i32 = LOG ;
        sv_setpv((SV*)cv, "") ;
        newXSproto("elog", XS__elog, file, "$$");
        newXSproto("quote_literal", XS__quote_literal, file, "$");
        newXSproto("quote_nullable", XS__quote_nullable, file, "$");
        newXSproto("quote_ident", XS__quote_ident, file, "$");
        newXSproto("decode_bytea", XS__decode_bytea, file, "$");
        newXSproto("encode_bytea", XS__encode_bytea, file, "$");
        newXSproto("looks_like_number", XS__looks_like_number, file, "$");
        newXSproto("encode_typed_literal", XS__encode_typed_literal, file, "$$");
    }

    /* Initialisation Section */

#line 218 "Util.xs"
    items = 0;  /* avoid 'unused variable' warning */

#line 365 "Util.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

